/*
 * ARJ+xenu is based on open-source ARJ by Andrew Belov <andrew_belov@newmail.ru>.
 *
 * Copyright (C) 2011 Tomasz Konojacki <xenu@poczta.onet.pl>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * ---------------------------------------------------------------------------
 * Prototypes of the functions located in ARJSEC_L.C are declared here.
 *
 */

#ifndef ARJSEC_L_INCLUDED
#define ARJSEC_L_INCLUDED

/* Prototypes */

int create_envelope(FILE *stream, unsigned long offset, int iter);

void arjsec_term(unsigned long *block, unsigned long *dest, int iter);
void arjsec_xor(unsigned long *dest, unsigned long *src);
void arjsec_newblock(unsigned long *dest);
void arjsec_invert(unsigned long *block);
void arjsec_crcterm(unsigned long *block, unsigned char c);
void arjsec_read(unsigned long *block, FILE *stream, unsigned long len);

void rev_arjsec_term(unsigned long *block, unsigned long *dest, int iter);
void arjsec_revert(unsigned long *block);

#endif

