/*
 * ARJ+xenu is based on open-source ARJ by Andrew Belov <andrew_belov@newmail.ru>.
 *
 * Copyright (C) 2011 Tomasz Konojacki <xenu@poczta.onet.pl>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * ---------------------------------------------------------------------------
 * This file defines basic constants depending on the given SFX_LEVEL
 *
 */

#ifndef BINDINGS_INCLUDED
#define BINDINGS_INCLUDED

#define C_DEFS_INCLUDED
#include <c_defs.h>

/* If the SFX_LEVEL is not given, default to the lowest one ever possible */

#ifndef SFX_LEVEL
 #ifdef SFL
  #define SFX_LEVEL              SFL
 #else
  #define SFX_LEVEL                0
 #endif
#endif

/* Bindings (SFX_LEVEL grades) */

#define ARJ                        4
#define ARJSFXV                    3
#define ARJSFX                     2
#define ARJSFXJR                   1

#if SFX_LEVEL>=ARJ
 #define FMSG_ST
 #define FARDATA                 FAR
 #define FARCODE                        /* Just indicates the far code model */
 #define EXTR_LEVEL  ARJ_X_SUPPORTED
#else
 #define FARDATA
 #define EXTR_LEVEL        ARJ_X_SFX
#endif

#if defined(USE_COLORS)&&(SFX_LEVEL>=ARJ||defined(REARJ))
 #define COLOR_OUTPUT
#endif

/* Debug information record. */

#ifdef DEBUG
 #define DEBUGHDR(fname) static char dbg_cur_file[]=fname; \
                         static int dbg_dummy;
#else
 #define DEBUGHDR(fname)
#endif

#endif
